; Remote Controller for Olympus Digital Camera
; 2008/11/08
; T. Nakagawa

; CPU Clock: 1MHz (Internal RC Osc.)
; PD0-6: IR-LED
; PB0: +
; PB1: -
; PB2: T
; PB3: W
; PB4: capture

.include "tn2313def.inc"

.def	IRLED_OFF=r16
.def	IRLED_ON=r17

.equ	BUF=SRAM_START

; interrupt vector
	rjmp	reset
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	rjmp	swint
	reti
	reti
	reti
	reti
	reti
	reti
	reti

reset:
	; register
	clr	IRLED_OFF
	ser	IRLED_ON
	; I/O
	ldi	ZL, 0xff
	out	PORTB, ZL
	out	DDRD, ZL
	; stack
	ldi	ZL, RAMEND
	out	SPL, ZL
	; sleep mode
	ldi	ZL, EXP2(SE)
	out	MCUCR, ZL
	; analog comparator off
	ldi	ZL, EXP2(ACD)
	out	ACSR, ZL
	; memory init.
	ldi	YL, LOW(BUF)
	ldi	YH, HIGH(BUF)
	ldi	ZL, 0b01100001
	st	Y+, ZL
	ldi	ZL, 0b11011100
	st	Y+, ZL
	; interruption enable
	ldi	ZL, EXP2(PCIE)
	out	GIMSK, ZL
	ldi	ZL, 0b00011111
	out	PCMSK, ZL
	sei
main:
	sleep
	rjmp	main

; vbVXCb`ɂ銄荞
swint:
	ldi	ZL, 0x00
	sbis	PINB, PINB0
	ldi	ZL, 0b10100000
	sbis	PINB, PINB1
	ldi	ZL, 0b00100000
	sbis	PINB, PINB2
	ldi	ZL, 0b11000000
	sbis	PINB, PINB3
	ldi	ZL, 0b01000000
	sbis	PINB, PINB4
	ldi	ZL, 0b10000000
	tst	ZL
	breq	si1
	ldi	YL, LOW(BUF + 2)
	ldi	YH, HIGH(BUF + 2)
	st	Y+, ZL
	com	ZL
	st	Y+, ZL
	rcall	irsend
	; 107ms̃EFCg
si0:	rcall	wait107ms
	; repeat(Ăs̃`FbN͏ȗDsĂƉ)
	in	ZL, PINB
	cpi	ZL, 0xff
	breq	si1
	rcall	irrepeat
	rjmp	si0
si1:	reti

; ԊOLEDɂMM(BUFn܂4oCg̃f[^𑗐M)
irsend:
	; Leader (8853us H + 4489us L)
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	wait560us
	rcall	wait560us
	rcall	wait560us
	rcall	wait560us
	rcall	wait560us
	rcall	wait560us
	rcall	wait560us
	rcall	wait560us
	; Data
	ldi	YL, LOW(BUF)
	ldi	YH, HIGH(BUF)
	rcall	pulse560us
is0:	ld	ZL, Y+
	ldi	ZH, 8
is1:	rcall	wait560us
	lsl	ZL
	brcc	is2
	rcall	wait560us
	rcall	wait560us
is2:	rcall	pulse560us
	dec	ZH
	brne	is1
	cpi	YL, LOW(BUF + 4)
	brne	is0
	ret

; ԊOLEDɂ郊s[gMM
irrepeat:
	; Leader (8853us H + 2259us L)
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	pulse560us
	rcall	wait560us
	rcall	wait560us
	rcall	wait560us
	rcall	wait560us
	rcall	pulse560us
	ret

; 38kHz̃pX560usԑM(=13usHigh13usLow3񑗐M+1us̃EFCg7JԂ@1MHz clock)
pulse560us:
	ldi	XL, 7
pls0:	out	PORTD, IRLED_ON
	rcall	wait10us
	nop
	nop
	out	PORTD, IRLED_OFF
	rcall	wait10us
	nop
	nop
	out	PORTD, IRLED_ON
	rcall	wait10us
	nop
	nop
	out	PORTD, IRLED_OFF
	rcall	wait10us
	nop
	nop
	out	PORTD, IRLED_ON
	rcall	wait10us
	nop
	nop
	out	PORTD, IRLED_OFF
	rcall	wait10us	; 1us̒ǉ̃EFCg܂
	dec	XL
	brne	pls0
	ret

; 10us̃EFCg(rcallCret܂)
wait10us:	; (3 clock - rcall)
	nop	; 1 clock
	nop	; 1 clock
	nop	; 1 clock
	ret	; 4 clock
; 560us̃EFCg
wait560us:
	ldi	XL, 184
w560us:	dec	XL
	brne	w560us
	ret

; 107ms̃EFCg
wait107ms:
	ldi	XH, 191
w107ms:	rcall	wait560us
	dec	XH
	brne	w107ms
	ret
